UNIT UMaus;
{Timo Schleicher 1999}
{$G+}
INTERFACE
   {Gibt den Maus Status zurck von x & y und den Maustasten links und rechts}
  PROCEDURE MausStatus (VAR MausX,MausY : Integer; VAR T1,T2 : Boolean);{reg}
  PROCEDURE MInfo(VAR x,y : integer; VAR lb,rb : boolean);              {ASM, das gleiche wie MausStatus}

   {Prft ob Maus Treiber vorhanden sind}
  FUNCTION  MDriverPresent : boolean;                                   {ASM}

   {Schaltet vorgegebene Grafik Maus an/aus}
  PROCEDURE Maus_an;                                                    {ASM}
  PROCEDURE Maus_aus;                                                   {ASM}

   {Setzt ein Fenster fr die Maus (im MSDOS Modus mit shl 3 !)}
  PROCEDURE MausFenstersetzen (x1,y1,x2,y2:Integer);                    {ASM}

   {Prft ob Maus da ist}
  FUNCTION  Maus_da : Boolean;                                          {reg}

   {Gibt Maus x & y zurck (im MSDOS Modus mit shr 3 !)}
  FUNCTION  mausx:Integer;                                              {ASM}
  FUNCTION  mausy:Integer;                                              {ASM}

   {Gibt an ob dir Maus IN dem Rechteck (x1,y1,x2,y2) liegt}
  FUNCTION  MB (x1,x2,y1,y2:Integer):Boolean;                           {Norm}

IMPLEMENTATION

USES dos;

PROCEDURE MInfo(VAR x,y : integer; VAR lb,rb : boolean);ASSEMBLER;
ASM
  mov  ax,$0003
  int  $33
  les  si,x
  mov  [es:si],cx
  les  si,y
  mov  [es:si],dx

  mov  ax,bx
  AND  al,1
  les  si,lb
  mov  [es:si],al
  SHR  bl,1
  AND  bl,1
  les  si,rb
  mov  [es:si],bl
END;

FUNCTION MDriverPresent : boolean; ASSEMBLER;
ASM
  mov  ax,$21
  int  $33
  cmp  ax,-1
  je           @found
  mov  ax,$0
  int  $33
  push ax
  mov  ax,$2
  int  $33
  pop  ax
@found:
  inc  ax
  xor  ax,1
END;

PROCEDURE MausStatus (VAR MausX,MausY : Integer; VAR T1,T2 : Boolean);
VAR regs:Registers;
BEGIN
   regs.ax:=$3;
   intr($33,regs);
   IF (regs.bx AND 1)<>0 THEN T1:=True
   ELSE T1:=False;
   IF (regs.bx AND 2)<>0 THEN T2:=True
   ELSE T2:=False;
   MausX:=regs.cx SHR 1;
   MausY:=regs.dx;
END;

PROCEDURE Maus_aus;ASSEMBLER;
ASM
  mov ax,2h
  int 33h
END;

PROCEDURE Maus_an;ASSEMBLER;
ASM
  mov ax,1h
  int 33h
END;

PROCEDURE MausFenstersetzen (x1,y1,x2,y2:Integer);ASSEMBLER;
ASM
  mov ax,7h
  mov cx,x1
  mov dx,x2
  int 33h
  mov ax,8h
  mov cx,y1
  mov dx,y2
  int 33h
END;

FUNCTION Maus_da : Boolean;
VAR regs:registers;
BEGIN
   regs.ax:=$0;
   intr($33,regs);
   Maus_da:=NOT (regs.ax=0);
END;

FUNCTION mausx:Integer;ASSEMBLER;
ASM
  mov ax,3h
  int 33h
  mov ax,cx
END;

FUNCTION mausy:Integer;ASSEMBLER;
ASM
  mov ax,3h
  int 33h
  mov ax,dx
END;

FUNCTION MB (x1,x2,y1,y2:Integer):Boolean;
BEGIN
   MB:=(x1<mausx) AND (x2>mausx) AND (y1<mausy) AND (y2>mausy);
END;

END.